
// ChildFrm.cpp : implementation of the CChildFrame class
//

#include "stdafx.h"
#include "Explore.h"

#include "ChildFrm.h"
#include "LeftView.h"
#include "ExploreView.h"

#include "ExploreTabbedView.h"
#include "ExploreScrollView.h"
#include "ExploreEditView.h"
#include "ExploreFormView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CChildFrame

IMPLEMENT_DYNCREATE(CChildFrame, CMDIChildWndEx)

BEGIN_MESSAGE_MAP(CChildFrame, CMDIChildWndEx)
	ON_WM_CLOSE()
	ON_UPDATE_COMMAND_UI_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, &CChildFrame::OnUpdateViewStyles)
	ON_COMMAND_RANGE(AFX_ID_VIEW_MINIMUM, AFX_ID_VIEW_MAXIMUM, &CChildFrame::OnViewStyle)
	ON_MESSAGE(WMU_HANDLEVIEWFORM, OnHandleViewForm)
END_MESSAGE_MAP()

// CChildFrame construction/destruction

CChildFrame::CChildFrame()
	:m_bInit(FALSE)
{
	// TODO: add member initialization code here
}

CChildFrame::~CChildFrame()
{
}

BOOL CChildFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/, CCreateContext* pContext)
{
	if(! m_wndSplitterMain.CreateStatic(this, 1, 2))
		return FALSE;
	if(! m_wndSplitterMain.CreateView(0, 0, RUNTIME_CLASS(CLeftView), CSize(0, 0), pContext))
	{
		m_wndSplitterMain.DestroyWindow();
		return FALSE;
	}
	if(! m_wndSplitterTab.CreateStatic(&m_wndSplitterMain, 2, 1, WS_CHILD | WS_VISIBLE | WS_BORDER, m_wndSplitterMain.IdFromRowCol(0, 1)))
	{
		m_wndSplitterTab.DestroyWindow();
		return FALSE;
	}
	if(! m_wndSplitterView.CreateStatic(&m_wndSplitterTab, 1, 2, WS_CHILD | WS_VISIBLE | WS_BORDER, m_wndSplitterTab.IdFromRowCol(0, 0)))
	{
		m_wndSplitterView.DestroyWindow();
		return FALSE;
	}
	if(! m_wndSplitterTab.CreateView(1, 0, RUNTIME_CLASS(CExploreTabbedView), CSize(0, 0), pContext))
	{
		m_wndSplitterTab.DestroyWindow();
		return FALSE;
	}
	if(! m_wndSplitterView.CreateView(0, 0, RUNTIME_CLASS(CExploreView), CSize(0, 0), pContext))
	{
		m_wndSplitterView.DestroyWindow();
		return FALSE;
	}
	if(! m_wndSplitterView.CreateView(0, 1, RUNTIME_CLASS(CExploreFormView), CSize(0, 0), pContext))
	{
		m_wndSplitterView.DestroyWindow();
		return FALSE;
	}

//	SetActiveView((CView*)m_wndSplitterMain.GetPane(0, 0));

//	return CMDIChildWndEx::OnCreateClient(lpcs, pContext);
	return TRUE;
}

void CChildFrame::ActivateFrame(int nCmdShow) 
{
	// TODO: Add your specialized code here and/or call the base class

	if(-1 == nCmdShow && NULL == GetNextWindow() && NULL == GetNextWindow(GW_HWNDPREV))
		nCmdShow = SW_SHOWMAXIMIZED;

	CMDIChildWndEx::ActivateFrame(nCmdShow);
}

BOOL CChildFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying the CREATESTRUCT cs
	if(! CMDIChildWndEx::PreCreateWindow(cs))
		return FALSE;

	return TRUE;
}

// CChildFrame diagnostics

#ifdef _DEBUG
void CChildFrame::AssertValid() const
{
	CMDIChildWndEx::AssertValid();
}

void CChildFrame::Dump(CDumpContext& dc) const
{
	CMDIChildWndEx::Dump(dc);
}
#endif //_DEBUG

// CChildFrame message handlers
CExploreView* CChildFrame::GetRightPane()
{
	CWnd* pWnd = m_wndSplitterMain.GetPane(0, 1);
	CExploreView* pView = DYNAMIC_DOWNCAST(CExploreView, pWnd);
	return pView;
}

void CChildFrame::OnUpdateViewStyles(CCmdUI* pCmdUI)
{
	if (! pCmdUI)
		return;

	// TODO: customize or extend this code to handle choices on the View menu.
	CExploreView* pView = GetRightPane(); 

	// if the right-hand pane hasn't been created or isn't a view, disable commands in our range
	if (pView == NULL)
		pCmdUI->Enable(FALSE);
	else
	{
		DWORD dwStyle = pView->GetStyle() & LVS_TYPEMASK;
		// if the command is ID_VIEW_LINEUP, only enable command
		// when we're in LVS_ICON or LVS_SMALLICON mode
		if (pCmdUI->m_nID == ID_VIEW_LINEUP)
		{
			if (dwStyle == LVS_ICON || dwStyle == LVS_SMALLICON)
				pCmdUI->Enable();
			else
				pCmdUI->Enable(FALSE);
		}
		else
		{
			// otherwise, use dots to reflect the style of the view
			pCmdUI->Enable();
			BOOL bChecked = FALSE;

			switch (pCmdUI->m_nID)
			{
			case ID_VIEW_DETAILS:
				bChecked = (dwStyle == LVS_REPORT);
				break;

			case ID_VIEW_SMALLICON:
				bChecked = (dwStyle == LVS_SMALLICON);
				break;

			case ID_VIEW_LARGEICON:
				bChecked = (dwStyle == LVS_ICON);
				break;

			case ID_VIEW_LIST:
				bChecked = (dwStyle == LVS_LIST);
				break;

			default:
				bChecked = FALSE;
				break;
			}

			pCmdUI->SetRadio(bChecked ? 1 : 0);
		}
	}
}

void CChildFrame::OnViewStyle(UINT nCommandID)
{
	// TODO: customize or extend this code to handle choices on the View menu.
	CExploreView* pView = GetRightPane();

	// if the right-hand pane has been created and is a CExploreView, process the menu commands...
	if (pView != NULL)
	{
		int nStyle = -1;

		switch (nCommandID)
		{
		case ID_VIEW_LINEUP:
			{
				// ask the list control to snap to grid
				CListCtrl& refListCtrl = pView->GetListCtrl();
				refListCtrl.Arrange(LVA_SNAPTOGRID);
			}
			break;

		// other commands change the style on the list control
		case ID_VIEW_DETAILS:
			nStyle = LVS_REPORT;
			break;

		case ID_VIEW_SMALLICON:
			nStyle = LVS_SMALLICON;
			break;

		case ID_VIEW_LARGEICON:
			nStyle = LVS_ICON;
			break;

		case ID_VIEW_LIST:
			nStyle = LVS_LIST;
			break;
		}

		// change the style; window will repaint automatically
		if (nStyle != -1)
			pView->ModifyStyle(LVS_TYPEMASK, nStyle);
	}
}

void CChildFrame::ShowDetail(BOOL bShow/* = TRUE*/)
{
	if(! bShow && ! m_wndSplitterTab.IsRow1Hidden())
	{
		m_wndSplitterView.HideCol1();
		m_wndSplitterTab.HideRow1();
	}
	if(bShow && m_wndSplitterTab.IsRow1Hidden())
	{
		m_wndSplitterView.ShowCol1();
		m_wndSplitterTab.ShowRow1();
	}

	if(! m_bInit)
		RestoreSplitters();
}

void CChildFrame::OnClose() 
{
	// TODO: Add your message handler code here

	int nWidth = 0, nMin = 0;
	m_wndSplitterMain.GetColumnInfo(0, nWidth, nMin);
	theApp.WriteProfileInt(_T("Settings"), _T("ExploreSplitterMainWidth"), nWidth);
	if(! m_wndSplitterTab.IsRow1Hidden())
	{
		int nHeight = 0;
		m_wndSplitterTab.GetRowInfo(0, nHeight, nMin);
		theApp.WriteProfileInt(_T("Settings"), _T("ExploreSplitterTabHeight"), nHeight);
		m_wndSplitterView.GetColumnInfo(0, nWidth, nMin);
		theApp.WriteProfileInt(_T("Settings"), _T("ExploreSplitterViewWidth"), nWidth);
	}

	CMDIChildWndEx::OnClose();
}

void CChildFrame::RestoreSplitters()
{
	if(m_bInit)
		return;

	m_bInit = TRUE;

	CRect rect;
	GetClientRect(&rect);

	int nWidth = (int)theApp.GetProfileInt(_T("Settings"), _T("ExploreSplitterMainWidth"), rect.Width() / 7);
	m_wndSplitterMain.SetColumnInfo(0, nWidth, 0);
	m_wndSplitterMain.RecalcLayout();
	int nHeightAsset = (int)theApp.GetProfileInt(_T("Settings"), _T("ExploreSplitterTabHeight"), rect.Height() / 4);
	m_wndSplitterTab.SetRowInfo(0, nHeightAsset, 0);
	m_wndSplitterTab.RecalcLayout();
	nWidth = (int)theApp.GetProfileInt(_T("Settings"), _T("ExploreSplitterViewWidth"), rect.Width() - nWidth / 2);
	m_wndSplitterView.SetColumnInfo(0, nWidth, 0);
	m_wndSplitterView.RecalcLayout();
}

CLeftView* CChildFrame::GetExploreTree()
{
	CWnd* pWnd = m_wndSplitterMain.GetPane(0, 0);
	return DYNAMIC_DOWNCAST(CLeftView, pWnd);
}

CExploreView* CChildFrame::GetExploreView()
{
	CWnd* pWnd = m_wndSplitterView.GetPane(0, 0);
	return DYNAMIC_DOWNCAST(CExploreView, pWnd);
}

CExploreTabbedView* CChildFrame::GetExploreTabbed()
{
	CWnd* pWnd = m_wndSplitterTab.GetPane(1, 0);
	return DYNAMIC_DOWNCAST(CExploreTabbedView, pWnd);
}

LRESULT CChildFrame::OnHandleViewForm(WPARAM wParam, LPARAM lParam)
{
	return ::SendMessage(GetExploreTabbed()->GetSafeHwnd(), WMU_HANDLEVIEWFORM, 0, 0);
}
