
// ChildFrm.h : interface of the CChildFrame class
//

#include "SplitterWndExplore.h"

#pragma once

class CLeftView;
class CExploreView;
class CExploreTabbedView;

class CChildFrame : public CMDIChildWndEx
{
	DECLARE_DYNCREATE(CChildFrame)
public:
	CChildFrame();
	void RestoreSplitters();
	CLeftView* GetExploreTree();
	CExploreView* GetExploreView();
	CExploreTabbedView* GetExploreTabbed();

// Attributes
protected:
	BOOL m_bInit;
	CSplitterWndExplore m_wndSplitterMain;
	CSplitterWndExplore m_wndSplitterTab;
	CSplitterWndExplore m_wndSplitterView;

// Operations
public:
	void ShowDetail(BOOL bShow = TRUE);

// Overrides
public:
	virtual void ActivateFrame(int nCmdShow = -1);
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CChildFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CExploreView* GetRightPane();
// Generated message map functions
protected:
	afx_msg void OnUpdateViewStyles(CCmdUI* pCmdUI);
	afx_msg void OnViewStyle(UINT nCommandID);
	afx_msg void OnClose();
	afx_msg LRESULT OnHandleViewForm(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};
