// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#pragma once

#include "ExploreDoc.h"

class CExploreTabbedView : public CTabView
{
protected: // create from serialization only
	CExploreTabbedView();
	DECLARE_DYNCREATE(CExploreTabbedView)

protected:
	virtual void AddView1();
	virtual void AddView2();
	virtual void AddView3();
	virtual void AddView4();
	virtual void AddView5();
	virtual void AddViewForm(int nIndex = -1);
	virtual void AddEntityView(int nEntity);
	virtual int AddView(CRuntimeClass* pViewClass, const CString& strViewLabel, int iIndex = -1, CCreateContext* pContext = NULL, BOOL bAfterCreation = FALSE);

protected:
	int m_nIndexForm;	// when m_nIndexForm is -1, then is visible, when m_nIndexForm >= 0, is hidden

// Attributes
public:
	CExploreDoc* GetDocument();

// Operations
public:
	int RemoveViewForm();

// Overrides
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	BOOL IsScrollBar() const {return TRUE;}

// Implementation
public:
	virtual ~CExploreTabbedView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	// Generated message map functions
	//{{AFX_MSG(CExploreTabbedView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	afx_msg void OnFilePrintPreview();
	//}}AFX_MSG
	afx_msg LRESULT OnHandleViewForm(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in TabbedViewView.cpp
inline CExploreDoc* CExploreTabbedView::GetDocument()
   { return (CExploreDoc*)m_pDocument; }
#endif
