
// LeftView.cpp : implementation of the CLeftView class
//

#include "stdafx.h"
#include "Explore.h"

#include "ExploreDoc.h"
#include "LeftView.h"

#include "ChildFrm.h"
#include "ExploreView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CLeftView

IMPLEMENT_DYNCREATE(CLeftView, CTreeView)

BEGIN_MESSAGE_MAP(CLeftView, CTreeView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
END_MESSAGE_MAP()

// CLeftView construction/destruction

CLeftView::CLeftView()
{
	// TODO: add construction code here
}

CLeftView::~CLeftView()
{
}

BOOL CLeftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying the CREATESTRUCT cs

	cs.style |= TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;

	return CTreeView::PreCreateWindow(cs);
}

void CLeftView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();

	// TODO: You may populate your TreeView with items by directly accessing
	//  its tree control through a call to GetTreeCtrl().

	HTREEITEM hRoot = GetTreeCtrl().InsertItem(_T("Root (no tabbed view)"));
	HTREEITEM hItem = GetTreeCtrl().InsertItem(_T("No tabbed view"), hRoot);
	GetTreeCtrl().SetItemData(hItem, 0);
	hItem = GetTreeCtrl().InsertItem(_T("With test-form-view"), hRoot);
	GetTreeCtrl().SetItemData(hItem, 1);
	hItem = GetTreeCtrl().InsertItem(_T("Without test-form-view"), hRoot);
	GetTreeCtrl().SetItemState(hItem, TVIS_BOLD, TVIS_BOLD);
	GetTreeCtrl().SetItemData(hItem, 2);
	GetTreeCtrl().Expand(hRoot, TVE_EXPAND);
	hItem = GetTreeCtrl().InsertItem(_T("With test-form-view 222"), hRoot);
	GetTreeCtrl().SetItemData(hItem, 1);
	hItem = GetTreeCtrl().InsertItem(_T("With test-form-view 333"), hRoot);
	GetTreeCtrl().SetItemData(hItem, 1);
}

// CLeftView diagnostics

#ifdef _DEBUG
void CLeftView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CLeftView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CExploreDoc* CLeftView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CExploreDoc)));
	return (CExploreDoc*)m_pDocument;
}
#endif //_DEBUG

// CLeftView message handlers

void CLeftView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	int nItemData = 0;
	CTreeCtrl& Tree = GetTreeCtrl();
	HTREEITEM hSelectedItem = pNMTreeView->itemNew.hItem;
	if(NULL != hSelectedItem)
		nItemData = (int)Tree.GetItemData(hSelectedItem);
	CChildFrame* pChild = (CChildFrame*)GetParentFrame();
	CExploreView* pView = (CExploreView*)pChild->GetExploreView();

	if(1 == nItemData || 2 == nItemData)
	{
		pChild->ShowDetail();
		pView->PopulateDetail();
	}
	else
	{
		pChild->ShowDetail(FALSE);
		pView->PopulateAsset();
	}

	GetDocument()->UpdateAllViews(NULL, 1);

	if(1 == nItemData || 2 == nItemData)
		pChild->PostMessage(WMU_HANDLEVIEWFORM);

	*pResult = 0;
}
